#ifndef evq_h
#define evq_h

#include <stdint.h>

enum ev_type {
	EV_TIMER = 1,
	EV_GPS = 2,
	EV_DBG = 4,
	EV_BTN = 8,
	EV_SCR = 16,
	EV_LED = 32,
	EV_SND = 64,
	EV_SD = 128,
	EV_ALL = 255,
};

struct ev_timer {
	enum ev_type type;
	uint8_t interval;
	uint8_t jitter;
};

struct ev_gps {
	enum ev_type type;
	uint8_t data;
};

struct ev_dbg {
	enum ev_type type;
	uint8_t id;
};

struct ev_btn {
	enum ev_type type;
	uint8_t id;
};

struct ev_scr {
	enum ev_type type;
	uint8_t id;
};

struct ev_led {
	enum ev_type type;
	uint8_t id;
};

struct ev_snd {
	enum ev_type type;
	uint8_t id;
};

struct ev_sd {
	enum ev_type type;
	uint8_t id;
};


typedef union {
	enum ev_type type;
	struct ev_timer timer;
	struct ev_gps gps;
	struct ev_dbg dbg;
	struct ev_btn btn;
	struct ev_scr scr;
	struct ev_led led;
	struct ev_snd snd;
	struct ev_sd sd;
} ev;

void evq_init(void);
void evq_register(enum ev_type mask, void (*fn)(ev *e, void *data), void *data);
void evq_push(ev *ev);
void evq_pop(ev *ev);
void evq_wait(ev *ev);

#endif