#include <avr/io.h>


#include "init.h" 


void init_init(void)
{
	// Do some general things here for this specific MCU
}


void init_spi(void)
{
	/* General SPI Settings */
	
	// Initialize on-board SPI hardware 
	
	// SPCR is the master register that contains
	// the bits to initialize SPI and control it.
		
	// SPE bit = SPI enabled
	// MSTR bit = Set SPI as Master
	// Set SPI as fast as possible 1,0,0 = f(osc)/2 <- smallest divider
	
	/* 
	Other clock rate settings that are possible:
	SPI2X	SPR1	SPR0	SCK Frequency
	0		0		0		f(osc)/4
	0		0		1		f(osc)/16
	0		1		0		f(osc)/64
	0		1		1		f(osc)/128
	1		0		0		f(osc)/2
	1		0		1		f(osc)/8
	1		1		0		f(osc)/32
	1		1		1		f(osc)/64
	*/
	
	// SPI SPE = Enabled, MSTR = Master, SPI2X, SPR1, SPR0 = speed
	SPCR = (1<<SPE)|(1<<MSTR)|(1<<SPI2X)|(0<<SPR1)|(0<<SPR0);
	
	// Set SPI_SS'
	SPI_PORT |= (1<<SPI_SS);	
	
	// Initialize DPY SPI Control Register: CS, RESET and DC pins
	DPY_CTRL_REG |= (1<<DPY_CS)|(1<<DPY_RST)|(1<<DPY_DC);
	
	// set MOSI, SCK and SS
	SPI_REG |= (1<<SPI_MOSI)|(1<<SPI_SCK)|(1<<SPI_SS);
	
	// Set the display (DPY) Port's CS (chip select) and RESET
	DPY_PORT |= (1<<DPY_CS)|(1<<DPY_RST);
	
	// Set the SD Card's (SDC) CS (chip select)
	SDC_PORT |= (1<<SDC_CS_PIN);
	
	// Set SD Card LED pin
	SDC_LED_REG |= (1<<SDC_LED_PIN);
	
	// Test
	SDC_LED_PORT |= (1<<SDC_LED_PIN);		// debug led
}


void init_uart(void){
	//
}


/*
 * End
 */
