#ifndef sd_h 
#define sd_h

/*
Sources:
http://www.dejazzer.com/ee379/lecture_notes/lec12_sd_card.pdf

http://elm-chan.org/docs/mmc/mmc_e.html
init: http://elm-chan.org/docs/mmc/gx1/sdinit.png

http://avrprojects.info/avr-tutorials/reading-and-writing-sd-card-using-atmega16/


*/

void sd_cs_assert(void);			// Set CS high
void sd_cs_deassert(void);			// Set CS low
void sd_init(void); 				// Initialise all settings for sdcards, CALL FIRST
uint8_t sd_send_cmd(char c);		// Send a command
uint8_t sd_init_card(void);			// Initialise sdcard, if inserted
uint8_t sd_reset(void);				// Reset a card, if errors on an inserted card occur
uint8_t sd_flush(void);				// Flush memory buffer to sd card
uint8_t sd_powerdown(void);			// Power down an inserted card, needs init to reestablish comms
uint8_t sd_powerup(void);			// Power up an inserted card, using power, calls init as well to reestablish comms
uint8_t sd_write_block(void);		// Write a block
uint8_t sd_read_block(void);		// Reads a block

#endif 